﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.Activities;

namespace LCContracts
{
    [ExternalDataExchange]
    public interface ITaskService
    {
        void CreateTask(Task newTask, string defaultUser);
        void AssignTask(Task task, string user);
        //void DeleteTask(Task task, string reason);
        event EventHandler<TaskEventArgs> TaskCompleted;
    }

    [Serializable]
    public class TaskEventArgs : ExternalDataEventArgs
    {
        public TaskEventArgs(Guid instanceId, Task task) : base(instanceId)
        {
            this.Task = task;
            base.WaitForIdle = true;
        }

        public Task Task { get; set; }
    }

    [Serializable]
    public class Task
    {
        public string Name { get; set; }
        public string Description { get; set; }
        public int Priority { get; set; }
        public DateTime DateDue { get; set; }

        public override string ToString()
        {
            return String.Format("{0}:{1}", Name, DateDue);
        }
    }
}
