﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using System.Workflow.Activities;
using LCContracts;
using LCContractsV2;

namespace LocalCommunications
{
    class Program
    {
        static void Main(string[] args)
        {
            using(WorkflowRuntime workflowRuntime = new WorkflowRuntime())
            {
                ExternalDataExchangeService eds = new ExternalDataExchangeService();
                workflowRuntime.AddService(eds);
                TaskService ts = new TaskService2();
                eds.AddService(ts);
                

                SqlWorkflowPersistenceService sql = new SqlWorkflowPersistenceService("server=.;database=workflowpersistence;integrated security=SSPI", true, new TimeSpan(0,2,0), new TimeSpan(0,2,0));
                
                workflowRuntime.AddService(sql);

                workflowRuntime.StartRuntime();

                AutoResetEvent waitHandle = new AutoResetEvent(false);
                workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) {waitHandle.Set();};
                workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
                {
                    Console.WriteLine(e.Exception.Message);
                    waitHandle.Set();
                };


                if (args.Length == 0)
                {
                    for (int i = 0; i < 10; i++)
                    {
                        WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(LocalCommunications.Workflow1));
                        instance.Start();
                        Console.WriteLine("Started: {0}", instance.InstanceId);
                    }
                    
                }
                else
                {
                    foreach (SqlPersistenceWorkflowInstanceDescription i in sql.GetAllWorkflows())
                    {
                        Guid id = i.WorkflowInstanceId;
                        ts.OnTaskCompleted(new Task { DateDue = DateTime.Now.AddDays(1), Description = "some task description", Name = "Do work", Priority = 1 }, id);
                    }
                }

                Console.ReadLine();
            }
        }
    }
}
